#include "Klocek.h"
#include "Dialogs.hpp"

CKlocek::CKlocek(int t,int x,int y,CPlansza* P)
{
	typ=t;
	pozycja=1;
	kolor=t-1;
	draw=false;
	this->x=x;
	this->y=y;
	Plansza=P;
}

void CKlocek::Rysuj()
{
	parametry P=Ksztalt();

//usun jesli narysowany
	if(draw)
	{
		Plansza->Usun(P.X1,P.Y1);
		Plansza->Usun(P.X2,P.Y2);
		Plansza->Usun(P.X3,P.Y3);
		Plansza->Usun(P.X4,P.Y4);
		draw=false;
	}
//narysuj jesli jest miejsce
	else
	{   if(Plansza->Visible(P.X1,P.Y1)||(Plansza->Visible(P.X2,P.Y2))||
			(Plansza->Visible(P.X3,P.Y3))||(Plansza->Visible(P.X4,P.Y4)))
		{
			draw=false;
		}
		else
		{
			Plansza->Dodaj(P.X1,P.Y1,kolor);
			Plansza->Dodaj(P.X2,P.Y2,kolor);
			Plansza->Dodaj(P.X3,P.Y3,kolor);
			Plansza->Dodaj(P.X4,P.Y4,kolor);
			draw=true;
		}
	}
}

int CKlocek::Sprawdz(int x)
{
	parametry P=Ksztalt();
	if(P.Y1==x) return(1);
	if(P.Y2==x) return(1);
	if(P.Y3==x) return(1);
	if(P.Y4==x) return(1);

	return(0);
}

parametry CKlocek::Ksztalt()
{
 parametry P;

 switch(typ)
 {
	 case 1: switch(pozycja)
			 {
				case 1:
				case 3:	P.X1=x; P.Y1=y;			//X
						P.X2=x; P.Y2=y-1;		//X
						P.X3=x; P.Y3=y-2;		//X
						P.X4=x; P.Y4=y-3;		//X
						return(P);
				case 2:
				case 4: P.X1=x-1; P.Y1=y;		//XXXX.
						P.X2=x;   P.Y2=y;
						P.X3=x+1; P.Y3=y;
						P.X4=x+2; P.Y4=y;
						return(P);
				default: ShowMessage("Wrong block position.");
			 }
			 break;
	 case 2: switch(pozycja)
			 {
				case 1: P.X1=x;   P.Y1=y;		//X
						P.X2=x;   P.Y2=y-1;		//X
						P.X3=x;   P.Y3=y-2;		//XX
						P.X4=x+1; P.Y4=y-2;
						return(P);
				case 2: P.X1=x+1; P.Y1=y;		//..X
						P.X2=x-1; P.Y2=y-1;		//XXX
						P.X3=x;   P.Y3=y-1;
						P.X4=x+1; P.Y4=y-1;
						return(P);
				case 3: P.X1=x;   P.Y1=y;		//XX
						P.X2=x+1; P.Y2=y;		//.X
						P.X3=x+1; P.Y3=y-1;		//.X
						P.X4=x+1; P.Y4=y-2;
						return(P);
				case 4: P.X1=x-1; P.Y1=y;		//XXX
						P.X2=x;   P.Y2=y;		//X..
						P.X3=x+1; P.Y3=y;
						P.X4=x-1; P.Y4=y-1;
						return(P);
				default: ShowMessage("Wrong block position.");
			 }
			 break;
	 case 3: P.X1=x;   P.Y1=y;		//XX
			 P.X2=x+1; P.Y2=y;		//XX
			 P.X3=x;   P.Y3=y-1;
			 P.X4=x+1; P.Y4=y-1;
			 return(P);
	 case 4: switch(pozycja)
			 {
				case 1:
				case 3: P.X1=x;   P.Y1=y;		//XX.
						P.X2=x+1; P.Y2=y;		//.XX
						P.X3=x+1; P.Y3=y-1;
						P.X4=x+2; P.Y4=y-1;
						return(P);
				case 2:
				case 4: P.X1=x+1; P.Y1=y;		//.X
						P.X2=x;   P.Y2=y-1;		//XX
						P.X3=x+1; P.Y3=y-1;		//X.
						P.X4=x;   P.Y4=y-2;
						return(P);
				default: ShowMessage("Wrong block position.");
			 }
			 break;
	case 5: switch(pozycja)
			{
				case 1: P.X1=x;   P.Y1=y;		//XXX
						P.X2=x+1; P.Y2=y;		//.X.
						P.X3=x+2; P.Y3=y;
						P.X4=x+1; P.Y4=y-1;
						return(P);
				case 2: P.X1=x;   P.Y1=y;		//X.
						P.X2=x;   P.Y2=y-1;		//XX
						P.X3=x+1; P.Y3=y-1;		//X.
						P.X4=x;   P.Y4=y-2;
						return(P);
				case 3: P.X1=x+1; P.Y1=y;		//.X.
						P.X2=x;   P.Y2=y-1;		//XXX
						P.X3=x+1; P.Y3=y-1;
						P.X4=x+2; P.Y4=y-1;
						return(P);
				case 4: P.X1=x+1; P.Y1=y;		//.X
						P.X2=x;   P.Y2=y-1;		//XX
						P.X3=x+1; P.Y3=y-1;		//.X
						P.X4=x+1; P.Y4=y-2;
						return(P);
				default: ShowMessage("Wrong block position.");
			}
			break;
	 case 6: switch(pozycja)
			 {
				case 1: P.X1=x+1; P.Y1=y;		//.X
						P.X2=x+1; P.Y2=y-1;		//.X
						P.X3=x+1; P.Y3=y-2;		//XX
						P.X4=x;   P.Y4=y-2;
						return(P);
				case 2: P.X1=x-1; P.Y1=y;		//XXX
						P.X2=x;   P.Y2=y;		//..X
						P.X3=x+1; P.Y3=y;
						P.X4=x+1; P.Y4=y-1;
						return(P);
				case 3: P.X1=x;   P.Y1=y;		//XX
						P.X2=x+1; P.Y2=y;		//X.
						P.X3=x;   P.Y3=y-1;		//X.
						P.X4=x;   P.Y4=y-2;
						return(P);
				case 4: P.X1=x-1; P.Y1=y;		//X..
						P.X2=x-1; P.Y2=y-1;		//XXX
						P.X3=x;   P.Y3=y-1;
						P.X4=x+1; P.Y4=y-1;
						return(P);
				default: ShowMessage("Wrong block position.");
			 }
			 break;
	 case 7: switch(pozycja)
			 {
				case 1:
				case 3: P.X1=x+1; P.Y1=y;		//.XX
						P.X2=x+2; P.Y2=y;		//XX.
						P.X3=x;   P.Y3=y-1;
						P.X4=x+1; P.Y4=y-1;
						return(P);
				case 2:
				case 4: P.X1=x;  P.Y1=y;		//X.
						P.X2=x;   P.Y2=y-1;		//XX
						P.X3=x+1; P.Y3=y-1;		//.X
						P.X4=x+1; P.Y4=y-2;
						return(P);
				default: ShowMessage("Wrong block position.");
			 }
			 break;
	default: ShowMessage("Wrong block type.");
 }
 return(P);
}


